#! ruby -Ks
  # exl18.rb  (coding: Windows-31J)  2015/07/12
  # Copyright (C) T. Yoshiizumi, 2012-2015 All rights reserved.
require "erb"
require "stringio"
require "exlap"
require "yados"
require "rrx"
require "wrdap"
require "hpricot"
require "pptap"
require "pstore"
require "exltool"

module Exltmp
  ExltmpS = Struct.new(:filename, :temp, :body, :tail, :str, :ary)
  module_function()

  def init()
    @wsh = WIN32OLE.new("WScript.Shell")
    @sendto_dir = @wsh.SpecialFolders("SendTo")
    @bat_file = "ExlRun18.bat"
    @bat_fullpath = "#{@sendto_dir}\\#{@bat_file}"
    @exe_file = defined?(ExerbRuntime) ? ExerbRuntime.filepath :
        ENV['OCRA_EXECUTABLE']
    @base_dir = @exe_file ? File.dirname(@exe_file.gsub(/\\/, "/")) : "."
    @bat_header1 = "@echo off\n" + "SET EXLCMD=#{@exe_file}\n" +
        "IF EXIST \"%EXLCMD%\" GOTO EXLEXEC\n" +
        "SET EXLCMD=%~dp0%exl18.exe\n" +
        "IF EXIST \"%EXLCMD%\" GOTO EXLEXEC\n" +
        "SET EXLCMD=exl18.exe\n" + ":EXLEXEC\n" +
        "\"%EXLCMD%\" -x \"%~f0\" %*\n" + 
        "GOTO :EOF\n\n" + "#! ruby\n"
    @bat_header2 = "@echo off\n" + "SET EXLCMD=#{@exe_file}\n" +
        "IF EXIST \"%EXLCMD%\" GOTO EXLEXEC\n" +
        "SET EXLCMD=%~dp0%exl18.exe\n" +
        "IF EXIST \"%EXLCMD%\" GOTO EXLEXEC\n" +
        "SET EXLCMD=exl18.exe\n" + ":EXLEXEC\n" +
        "\"%EXLCMD%\" -x \"%~f0\" %* >!stdout.txt 2>!stderr.txt\n" +
        "FOR %%I IN (!std*.txt) DO IF %%~zI EQU 0 DEL %%I\n" +
        "GOTO :EOF\n\n" + "#! ruby\n"
    @msg_file = Exl::fullpath( "#{@base_dir}/exl_msg.txt" )
    WIN32OLE.new("Scripting.FileSystemObject").Drives.each do |drv|
      if "#{drv.DriveLetter}" == @msg_file[0,1].upcase
        if !drv.IsReady or drv.FreeSpace < 100 or
            drv.DriveType == 0 or drv.DriveType == 4
          @msg_file = nil
        end
        break
      end
    end
    File.unlink(@msg_file)  if @msg_file and test(?f, @msg_file)
    if @base_dir != "." and test(?e, "#{@base_dir}/pandoc.exe")
      PandocRuby.bin_path = @base_dir
    end
    if @base_dir != "." and test(?e, "#{@base_dir}/exlauto.rb")
      require "#{@base_dir}/exlauto"
    end
    @s = ExltmpS.new(nil, nil, nil, nil, nil, nil)
  end

  def s()
    return @s
  end

  def make_bat()
    bat_regex1 = /\A# +make +bat\n/i
    bat_regex2 = /\A# +make +bat *\>\n/i
    fname = @s.filename
    body = File.read(fname)
    if body =~ bat_regex1
      bat_header = @bat_header1
    elsif body =~ bat_regex2
      bat_header = @bat_header2
    else
      return nil
    end
    body = body.sub(/\A.+?\n/, "")
    bat_name = fname.sub(/\.[^.]*$/, "") + ".bat"
    bat_content = bat_header + body
    File.open(bat_name, "w") {|ff|  ff.print bat_content}
    bat_content = nil
    return bat_name
  end

  def prepare()
    init()
    if ARGV.size < 1
      if @exe_file and test(?e, @bat_fullpath)
        File.unlink(@bat_fullpath)
        wmsg = "uvj[ '#{@bat_file}' ܂."
        @wsh.Popup(wmsg, 0, "exl message")
      elsif @exe_file
        bat_contents = "@echo off\nCD /D \"%~dp1\"\n" +
            "\"#{@exe_file}\" \"%~f1\" >!stdout.txt 2>!stderr.txt\n" +
            "FOR %%I IN (!std*.txt) DO IF %%~zI EQU 0 DEL %%I\n"
        File.open(@bat_fullpath, "w") {|ff|  ff.write bat_contents}
        bat_contents = nil
        wmsg = "uvj[ '#{@bat_file}' o^܂."
        @wsh.Popup(wmsg, 0, "exl message")
      else
        wmsg = "'exl18.exe' ̃tpXcł܂."
        @wsh.Popup(wmsg, 0, "exl message")
      end
    elsif ARGV[0] =~ /^(\/|-)(help|h)$/i
      wmsg = "exl18.exe: ExcelWord삷rubyXNvgs.\n" +
        "usage: exl18.exe ruby_script [argv1 argv2  ...]  " +
        "XNvg̎s\n" +
        "  exl18.exe  ȂŎs:" +
        "uvj[ExlRun18.bat̓o^|\n" +
        "  exl18.exe -sample C:\\work  sample.batwtH_ɏo\n" +
        "  exl18.exe -help  wv̕\\n" +
        "  sample.bat, -xIvV̗pɂȂĂ.\n"
      print wmsg
    elsif ARGV[0] =~ /^(\/|-)(sample|s)$/i
        zzdir = ""
        if ARGV.size > 1 and test(?d, ARGV[1])
          zzdir = ARGV[1]
          zzdir = zzdir.gsub(/\//, "\\")
          zzdir = zzdir.sub(/\\$/, "") + "\\"
        end
        bat_contents = @bat_header1 +
            "Exlap.new(\"sample.xls\") do |wb|\n" +
            "  ss = wb.ss(1)\n  ss.Range(\"A1\").Value = " +
            "\"test\"\n  wb.save\nend\n"
        File.open(zzdir + "sample.bat", "w") {|ff|  ff.print bat_contents}
        bat_contents = nil
    elsif ARGV[0] =~ /^(\/|-)x$/
      ARGV.shift
      if ARGV.size > 0 and test(?f, ARGV[0]) and !test(?z, ARGV[0])
        fname = Exl::fullpath(ARGV.shift)
        body = File.open(fname) {|ff|  ff.read}
        if body =~ /^\#![^\n]*ruby/
          lines = body.split(/\n/)
          lines.each_with_index do |line, i|
            break  if line =~ /^\#!.*ruby/
            if i == 0
              if RUBY_VERSION.to_f >= 1.9
                etype = 'a'.encoding.to_s
                lines[i] = "# (coding: #{etype}) " + line
              else
                lines[i] = "# " + line
              end
            else
              lines[i] = "# " + line
            end
          end
          @s.temp = Tempfile.new(['exl', '.rb'])
          @s.temp.write lines.join("\n")+"\n"
          @s.temp.close
          @s.filename = fname
          fname = body = lines = nil
        else
          @s.filename = fname
          fname = nil
        end
      elsif ARGV.size > 0
        wmsg = "-xIvV̌ '#{ARGV[0]}' ܂܂."
        @wsh.Popup(wmsg, 0, "exl message")
      end
    elsif ARGV[0] =~ /^(\/|-)rmzero$/i
      ARGV.shift
      ARGV.each {|x|  File.unlink(x)  if test(?z,x)}
    else
      @s.filename = Exl::fullpath(ARGV.shift)
      if !test(?f, @s.filename) or test(?z, @s.filename)
        wmsg = "'#{@s.filename}' ܂܂."
        @wsh.Popup(wmsg, 0, "exl message")
        @s.filename = nil
      end
    end
    if @s.filename and !@s.temp
      if (bat_name = make_bat())
        wmsg = "ob`t@C '#{bat_name}' o͂܂."
        @wsh.Popup(wmsg, 0, "exl message")
        @s.filename = nil
      end
    end
    @wsh = @sendto_dir = @exe_file = nil
    @bat_file = @bat_fullpath = @bat_header1 = @bat_header2 = nil
  end

  def proc_err()
    if @s.str and @s.ary
      orgname = @s.filename.gsub(/\\/, "/")
      path1 = path2 = nil
      if @s.temp
        path1 = @s.temp.path
        path2 = (path1 =~ /\//) ?
            path1.gsub(/\//, "\\") : path1.gsub(/\\/, "/")
        if @s.str[path1] then  @s.str[path1] = orgname \
        elsif @s.str[path2] then  @s.str[path2] = orgname  end
      end
      pstr = ''
      @s.ary.each {|x|
        if path1 and path2
          if x[path1] then  x[path1] = orgname \
          elsif x[path2] then  x[path2] = orgname  end
        end
        pstr += "#{x}\n"
      }
      STDERR.puts @s.str + "\n"
      STDERR.puts pstr + "\n"
      File.open(@msg_file, "w") {|ff|
        ff.puts @s.str + "\n"
        ff.puts pstr + "\n"
      }  if @msg_file
    end
  end

  def final()
    $ExlapObject.quit()  if $ExlapObject != nil
    $WrdapObject.quit()  if $WrdapObject != nil
    $PptapObject.quit()  if $PptapObject != nil
  end
end

# pandoc_docx() ̏
module Wrd
  remove_method :pandoc_docx
  def self.pandoc_docx(str, *opt_ary)
    unless defined?(PandocRuby)
      STDERR.puts "'pandoc-ruby' has not loaded."
      return nil
    end
    hs, var, ary = pandoc_opt(opt_ary)
    if hs[:reference_docx] == nil
      exe_file = defined?(ExerbRuntime) ? ExerbRuntime.filepath :
          ENV['OCRA_EXECUTABLE']
      if exe_file
        r_file = File.dirname(exe_file.gsub(/\\/, "/")) + "/reference.docx"
        hs[:reference_docx] = r_file  if test(?e, r_file)
      end  
    end
    hs[:to] = :docx
    ary << hs
    var.each {|x|  ary.push({:V=>x})}
    return pandoc_convert(str, *ary)
  end
end

module Rrx
  remove_method :pandoc_docx
  def self.pandoc_docx(str, *opt_ary)
    unless defined?(PandocRuby)
      STDERR.puts "'pandoc-ruby' has not loaded."
      return nil
    end
    hs, var, ary = pandoc_opt(opt_ary)
    if hs[:reference_docx] == nil
      exe_file = defined?(ExerbRuntime) ? ExerbRuntime.filepath :
          ENV['OCRA_EXECUTABLE']
      if exe_file
        r_file = File.dirname(exe_file.gsub(/\\/, "/")) + "/reference.docx"
        hs[:reference_docx] = r_file  if test(?e, r_file)
      end  
    end
    hs[:to] = :docx
    ary << hs
    var.each {|x|  ary.push({:V=>x})}
    return pandoc_convert(str, *ary)
  end
end

## main
Exltmp::prepare()
if Exltmp::s.filename
  Exltmp::s.body = File.read(Exltmp::s.filename)
  if Exltmp::s.body =~ /\n__END__\n(.+)\Z/m
    Exltmp::s.tail = $1
    DATA = StringIO.new(Exltmp::s.body)
    DATA.pos = Exltmp::s.body.bytesize - Exltmp::s.tail.bytesize
  end
  Exltmp::s.body = Exltmp::s.tail = nil
  Exltmp::s.str = Exltmp::s.ary = nil
  begin
    !Exltmp::s.temp ? load(Exltmp::s.filename) : load(Exltmp::s.temp.path)
  rescue SyntaxError, RuntimeError, NameError, LoadError, StandardError
    Exltmp::s.str = $!.to_s
    Exltmp::s.ary = $@.dup
  end
  Exltmp::proc_err()
  Exltmp::s.temp.unlink  if Exltmp::s.temp
end
Exltmp::final()
