# exltool.rb for exl18.exe|exl21.exe (encoding: Windows-31J)  2015/03/26
  # call 'MessageBeep' function on user32.dll

module ExlTool
  SimpleBeep = -1  # WIȃr[v
  MB_OK = 0  # ʂ̌x
  MB_ICONHAND = 16  # VXeG[
  MB_ICONQUESTION = 32  # ⍇bZ[W
  MB_ICONEXCLAMATION = 48  # xbZ[W
  MB_ICONASTERISK = 64  # 񃁃bZ[W
  BeepType = {'BEEP'=>-1,  # WIȃr[v
   'OK'=>0,  # ʂ̌x
   'ERROR'=>16,  # VXeG[
   'QUESTION'=>32,  # ⍇bZ[W
   'EXCLAMATION'=>48,  # xbZ[W
   'ASTERISK'=>64,  # 񃁃bZ[W
   '?'=>32,  # ⍇bZ[W
   '!'=>48,  # xbZ[W
   '*'=>64}  # 񃁃bZ[W
end

if RUBY_VERSION < "2.0"
  require "Win32API"
  module ExlTool
    @@message_beep = Win32API.new('user32', 'MessageBeep', ['I'], 'I')
    @@kbhit = Win32API.new('msvcrt', '_kbhit', [], 'I')
    @@getch = Win32API.new('msvcrt', '_getch', [], 'I')

    module_function()
    def beep(beep_type)
      beep_type = BeepType[beep_type.upcase]  if beep_type.class == String
      if beep_type
        @@message_beep.call(beep_type)
      end
    end

    def kbhit()
      @@kbhit.call()
    end

    def getch()
      @@getch.call()
    end
  end
else
  require "fiddle"
  require "fiddle/import"
  module ExlTool
    module W
      extend Fiddle::Importer
      dlload 'user32.dll', 'msvcrt.dll'
      typealias("BOOL", "int")
      extern "BOOL MessageBeep(unsigned int)"
      extern "int _kbhit()"
      extern "int _getch()"
    end

    module_function()
    def beep(beep_type)
      beep_type = BeepType[beep_type.upcase]  if beep_type.class == String
      if beep_type
        W.MessageBeep(beep_type)
      end
    end

    def kbhit()
      W._kbhit()
    end

    def getch()
      W._getch()
    end
  end
end
